
#property copyright "Copyright Wise-EA Programming, Distributed as customized Modular Indicator"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern string INDI = " --- Custom Indicator Settings --- ";
extern int HMAPeriod_1 = 30;
extern int HMAPrice_1 = 0;
extern int HMAMethod_1 = 3;
extern int HMAPeriod_2 = 50;
extern int HMAPrice_2 = 0;
extern int HMAMethod_2 = 3;
extern int HMAPeriod_3 = 100;
extern int HMAPrice_3 = 0;
extern int HMAMethod_3 = 3;
extern string ALERT = " --- Alert Settings --- ";
extern bool AlertClosedBar = TRUE;
extern bool ShowVLine = FALSE;
extern color LineColor = Lime;
extern bool ShowAlertBox = TRUE;
extern bool PlayAudio = TRUE;
extern string AudioFile = "alert2.wav";
extern bool SendEmail = TRUE;
extern bool   alertsNotify     = TRUE;
extern string OTH = " --- Other Settings --- ";
extern string ID = " HMA Arrow ";
extern int BarLookBack = 2000;
extern double Gap = 20.0;
extern int Arrowsize = 3;
double G_ibuf_192[];
double G_ibuf_196[];
int G_digits_200;
double Gd_204;
string Gs_212;
int G_datetime_220;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   Gd_204 = MarketInfo(Symbol(), MODE_POINT);
   G_digits_200 = MarketInfo(Symbol(), MODE_DIGITS);
   if (G_digits_200 == 3 || G_digits_200 == 5) Gd_204 = 10.0 * Gd_204;
   SetIndexStyle(0, DRAW_ARROW, EMPTY, Arrowsize);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, G_ibuf_192);
   SetIndexLabel(0, "Up");
   SetIndexStyle(1, DRAW_ARROW, EMPTY, Arrowsize);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, G_ibuf_196);
   SetIndexLabel(0, "Dn");
   Gs_212 = ID + Symbol() + Period();
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   f0_0();
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   f0_2();
   return (0);
}

// CEF0E4B8060FEF9228AEF82C25618C95
string f0_4(int Ai_0) {
   double icustom_4 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_1, HMAPrice_1, HMAMethod_1, 1, 2, 0, 1, Ai_0);
   double icustom_12 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_1, HMAPrice_1, HMAMethod_1, 1, 2, 0, 3, Ai_0);
   double icustom_20 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_2, HMAPrice_2, HMAMethod_2, 1, 2, 0, 1, Ai_0);
   double icustom_28 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_2, HMAPrice_2, HMAMethod_2, 1, 2, 0, 3, Ai_0);
   double icustom_36 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_3, HMAPrice_3, HMAMethod_3, 1, 2, 0, 1, Ai_0);
   double icustom_44 = iCustom(NULL, 0, "HMA Color nrp", HMAPeriod_3, HMAPrice_3, HMAMethod_3, 1, 2, 0, 3, Ai_0);
   if (icustom_4 != EMPTY_VALUE && icustom_20 != EMPTY_VALUE && icustom_36 != EMPTY_VALUE) return ("Up");
   if (icustom_12 != EMPTY_VALUE && icustom_28 != EMPTY_VALUE && icustom_44 != EMPTY_VALUE) return ("Dn");
   return ("X");
}

// 892ECFB0BFB52040FC960A606D36B587
void f0_2() {
   int Li_4;
   int Li_12;
   int Li_8 = IndicatorCounted();
   if (Li_8 >= 0) {
      if (Li_8 > 0) Li_8--;
      Li_4 = BarLookBack;
      if (AlertClosedBar) Li_12 = 1;
      else Li_12 = 0;
      for (int Li_0 = Li_4; Li_0 >= Li_12; Li_0--) {
         if (f0_4(Li_0) == "Up" && f0_4(Li_0 + 1) != "Up") {
            G_ibuf_192[Li_0] = Low[Li_0] - Gap * Gd_204;
            f0_3(Li_0, " Bullish Signal!");
         } else {
            if (f0_4(Li_0) == "Dn" && f0_4(Li_0 + 1) != "Dn") {
               G_ibuf_196[Li_0] = High[Li_0] + Gap * Gd_204;
               f0_3(Li_0, " Bearish Signal!");
            }
         }
      }
   }
}

// 982BD28A16F858DCD331FA7D4D55520B
void f0_3(int Ai_0, string As_4) {
   string Ls_12;
   string Ls_20;
   if (Ai_0 < 2 && G_datetime_220 != iTime(NULL, 0, 0)) {
      if (ShowVLine) f0_1(Time[Ai_0], LineColor);
      if (ShowAlertBox) Alert(TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + " | " + Gs_212 + " | " + As_4);
      if (PlayAudio) PlaySound(AudioFile);
      if (SendEmail) {
         Ls_12 = Gs_212 + " Email Alert:" + As_4;
         Ls_20 = TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + " | " + Gs_212 + " | " + As_4;
         SendMail(Ls_12, Ls_20);
      }
      
       if (alertsNotify)  {
       
         Ls_12 = Gs_212 + "Notify Alert:" + As_4;
         Ls_20 = TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + " | " + Gs_212 + " | " + As_4;
        SendNotification(StringConcatenate(Symbol(), Period() ," HULL ARROW " +" "+(Ls_12+ Ls_20)));
      }
       
       //SendNotification(StringConcatenate(Symbol(), Period() ," HULL ARROW " +" "+message));
      G_datetime_220 = iTime(NULL, 0, 0);
   }
}

// 33CABF1A33745A6B0636C875B610214C
void f0_1(int A_datetime_0, int Ai_4) {
   string name_8 = Gs_212 + "-" + A_datetime_0 + " VLine";
   ObjectCreate(name_8, OBJ_VLINE, 0, A_datetime_0, 0);
   f0_5(name_8, Ai_4, STYLE_SOLID);
}

// F1C204179665F5C4FF4C85BE6CDB5523
void f0_5(string A_name_0, color A_color_8, int A_style_12) {
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_8);
   ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(A_name_0, OBJPROP_STYLE, A_style_12);
   ObjectSet(A_name_0, OBJPROP_TIMEFRAMES, NULL);
}

// 1295BD0766D450411297FF78E4068DA3
void f0_0() {
   string name_4;
   int Li_0 = 0;
   while (Li_0 < ObjectsTotal()) {
      name_4 = ObjectName(Li_0);
      if (StringSubstr(name_4, 0, StringLen(ID)) == ID) ObjectDelete(name_4);
      else Li_0++;
   }
}
